=== test/correlation/CMakeLists.txt ===
if(FFTW3_FOUND)
    INCLUDE_DIRECTORIES(${SUPPRESS_WARNINGS} ${FFTW3_INCLUDE_DIR})

    VIGRA_CONFIGURE_THREADING()

    VIGRA_ADD_TEST(test_correlation test.cxx LIBRARIES ${FFTW3_LIBRARIES} ${FFTW3F_LIBRARIES} ${THREADING_LIBRARIES})
else()
    MESSAGE(STATUS "** WARNING: fftw not found. test_correlation will not be executed")
endif()
