=== test/filters/CMakeLists.txt ===
VIGRA_ADD_TEST(test_filters test.cxx)
