=== test/sampler/CMakeLists.txt ===
VIGRA_ADD_TEST(test_sampler test.cxx)
