=== test/merge_graph_adaptor/CMakeLists.txt ===
VIGRA_ADD_TEST(test_merge_graph_adaptor test.cxx)
