=== test/permutation/CMakeLists.txt ===
VIGRA_ADD_TEST(test_permutation test.cxx LIBRARIES)
