=== test/watersheds3d/CMakeLists.txt ===
VIGRA_ADD_TEST(test_watersheds3d test.cxx LIBRARIES vigraimpex)
