=== debian/control ===
--- 
+++ 
@@ -1,12 +1,12 @@
 Source: libvigraimpex
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Andreas Metzler <ametzler@debian.org>
 Section: libs
 Priority: optional
 Build-Depends: cmake,
-               debhelper-compat (= 12),
-               dh-python,
+               debhelper-compat (= 13),
+               dh-sequence-python3,
+               dh-sequence-numpy3,
                libboost-python-dev,
                libfftw3-dev,
                libhdf5-dev,
@@ -16,16 +16,16 @@
                libtiff5-dev,
                python3-dev,
                python3-nose,
-               python3-numpy,
                libboost-thread-dev
-Build-Depends-Indep: doxygen,
+Build-Depends-Indep: dh-sequence-sphinxdoc,
+                     doxygen,
                      ghostscript,
                      python3,
                      python3-sphinx,
                      texlive-latex-base,
                      texlive-latex-extra
 Rules-Requires-Root: no
-Standards-Version: 4.4.1
+Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/science-team/libvigraimpex
 Vcs-Git: https://salsa.debian.org/science-team/libvigraimpex.git
 Homepage: https://ukoethe.github.io/vigra/
@@ -96,6 +96,7 @@
          ${misc:Depends},
          ${python3:Depends},
          ${shlibs:Depends}
+Recommends: python3-pyqt4
 Suggests: python3-h5py,
           python-vigra-doc
 Description: Python3 bindings for the C++ computer vision library
