=== debian/rules ===
--- 
+++ 
@@ -104,11 +104,5 @@
 		html/index.html
 endif
 
-override_dh_installdocs-indep:
-	dh_installdocs
-	# Cannot use dh $@ --with sphinxdoc since it is only available on
-	# arch-all builds.
-	dh_sphinxdoc
-
 %:
-	dh $@ --with python3,numpy3 --builddirectory=$(MAINBDIR) --no-parallel
+	dh $@ --builddirectory=$(MAINBDIR)
